package cn.flea.chexnetmaster.controller;

import cn.flea.chexnetmaster.pojo.Result;
import cn.flea.chexnetmaster.service.ProcessImgService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

@Slf4j
@RestController
@RequestMapping("/chexnet-master")
@CrossOrigin(origins = "*")
public class ImgProcessController {

    private String chexnetMasterImgApiUrl = null;

    @Autowired
    private ProcessImgService processImgService;

    @PostMapping("/processImg")
    public Result processImg(MultipartFile img) {
        if (chexnetMasterImgApiUrl == null) {
            log.error("未设置chexnetMasterImgApiUrl");
            return Result.error("未设置chexnetMasterImgApiUrl");
        }
        return processImgService.processImg(img,chexnetMasterImgApiUrl);
    }


    @PutMapping("/processImg")
    public Result saveImg(String chexnetMasterImgApiUrl) {
        if (chexnetMasterImgApiUrl != null || !chexnetMasterImgApiUrl.isEmpty()){
            this.chexnetMasterImgApiUrl = chexnetMasterImgApiUrl;
            log.info("更新chexnetMasterImgApiUrl为：{}", chexnetMasterImgApiUrl);
            return Result.success();
        }
        log.error("参数错误");
        return Result.error("参数错误");
    }


}
