package cn.flea.chexnetmaster.service.impl;

import cn.flea.chexnetmaster.pojo.Result;
import cn.flea.chexnetmaster.service.ProcessImgService;
import cn.flea.chexnetmaster.util.FileUploadUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import java.util.Map;

@Slf4j
@Service
public class ProcessImgServiceB implements ProcessImgService {

//    @Autowired
//    private GetChexnetMasterImgApiUrl getChexnetMasterImgApiUrl;
//
//    @PostConstruct
//    public void init() {
//        chexnetMasterImgApiUrl = getChexnetMasterImgApiUrl.getChexnetMasterImgApiUrl();
//    }

    @Override
    public Result processImg(MultipartFile img, String chexnetMasterImgApiUrl) {
        try {
            Map<String, Object> res = FileUploadUtil.uploadFileMap(chexnetMasterImgApiUrl, img, "img");
            log.info("图片处理结果：" + res.get("code") + res.get("msg"));
            Result result = new Result();
            // 检查并转换 code 值
            Object codeObj = res.get("code");
            if (codeObj instanceof Integer) {
                result.setCode((Integer) codeObj);
            } else if (codeObj instanceof Double) {
                result.setCode(((Double) codeObj).intValue());
            } else {
                throw new IllegalArgumentException("Unexpected type for code: " + codeObj.getClass().getName());
            }
            result.setMsg((String) res.get("msg"));
            result.setData(res.get("data"));

            log.info("处理图片完成");
            return result;

        } catch (Exception e){
            log.error("图片处理失败");
            return Result.error("图片处理失败");
        }
    }
}
