package cn.flea.chexnetmaster.controller;

import cn.flea.chexnetmaster.pojo.Result;
import cn.flea.chexnetmaster.service.ContentCheckService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

@Slf4j
@RestController
@RequestMapping("/contentCheck")
public class ContentCheck {

    @Autowired
    private ContentCheckService contentCheckService;

    @GetMapping("/textCheck")
    public Result textCheck(String text, @RequestAttribute("openid") String openid){
        log.info("待检查文本: " + text);

        Integer res = contentCheckService.textCheck(text,openid);
        log.info("文本审核结果: " + res);

        if (res == 1) return Result.success("PASS");
        if (res == 2) return Result.success("NO_PASS");

        return Result.error("文本审核失败");
    }

    @PostMapping("/imgCheck")
    public Result imgCheck(MultipartFile img, @RequestAttribute("openid") String openid){

        Integer res = contentCheckService.imgCheck(img,openid);
        log.info("图片审核结果: " + res);

        if (res == 1) return Result.success("PASS");
        if (res == 2) return Result.success("NO_PASS");

        return Result.error("图片审核失败");
    }
}
