package cn.flea.chexnetmaster.dao.impl;

import cn.flea.chexnetmaster.dao.PyDao;
import cn.flea.chexnetmaster.pojo.Result;
import cn.flea.chexnetmaster.util.FilePathUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.io.ResourceLoader;
import org.springframework.stereotype.Repository;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.IOException;
import java.util.List;

@Slf4j
@Repository
public class PyDaoA implements PyDao {
    @Autowired
    private ResourceLoader resourceLoader;

    @Autowired
    private FilePathUtil filePathUtil;

    private String pyPath = "visual.py";
    private String imgPath = "test\\";
    private String workingDir = "\\PythonApp\\";
    @Override
    public Result processImg(String InputImage, String OutputImage) {
        String InputWinImage = ".\\test\\" + InputImage;
        String OutputWinImage = ".\\test\\" + OutputImage;

        try {
            // 使用 Runtime 类执行 Python 脚本
            String cmd = "cmd /c cd /d " + filePathUtil.getProjectPath() + this.workingDir + " && python " + pyPath + " " + InputWinImage + " " + OutputWinImage;

            log.info("执行 Python 脚本：" + cmd);

            Process process = Runtime.getRuntime().exec(cmd);

            // 使用 try-with-resources 确保资源被正确关闭
            try (BufferedReader reader = new BufferedReader(new InputStreamReader(process.getInputStream()));
                 BufferedReader errorReader = new BufferedReader(new InputStreamReader(process.getErrorStream()))) {

                // 读取 Python 脚本的标准输出
                String line;
                StringBuilder pyOut = new StringBuilder();
                while ((line = reader.readLine()) != null) {
                    log.debug(line);
                    pyOut.append(line + "<br>");
                }
                log.info("Python 脚本输出：" + pyOut);
                // 读取 Python 脚本的错误输出
                while ((line = errorReader.readLine()) != null) {
                    System.err.println(line);
                }

                // 等待子进程结束
                int exitCode = process.waitFor();
                if (exitCode != 0) {
                    return Result.error("Python script failed with exit code: " + exitCode);
                }
                return Result.success(List.of(pyOut.toString()));
//                String OutputImageWinPath = filePathUtil.getFileWinPath(imgPath + OutputImage);
//                return Result.success(List.of(pyOut.toString(),OutputImage));
            }

        } catch (IOException | InterruptedException e) {
            e.printStackTrace();
            return Result.error("Error occurred: " + e.getMessage());
        }
    }

}
